"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

exports.default = createChanges;

var _slate = require("slate");

var _slateKitPluginsUtils = require("@vericus/slate-kit-plugins-utils");

var _tinycolor = require("tinycolor2");

var _tinycolor2 = _interopRequireDefault(_tinycolor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createChanges(opt) {
  var defaultColor = opt.defaultColor,
      data = opt.data,
      type = opt.type;

  return {
    changeColor: function changeColor(change, color) {
      var value = change.value;
      var selection = value.selection,
          document = value.document;

      if ((0, _slateKitPluginsUtils.hasMark)(value, type)) {
        if ((0, _tinycolor2.default)(color).toName() === defaultColor) {
          if (selection.isCollapsed) {
            (0, _slateKitPluginsUtils.removeCollapsedMark)(value, change, type);
          } else {
            (0, _slateKitPluginsUtils.removeExpandedMark)(document, selection, change, type);
          }
        } else {
          var newMark = new _slate.Mark({
            type: type,
            data: _slate.Data.create((0, _defineProperty3.default)({}, data, color))
          });
          if (selection.isCollapsed) {
            (0, _slateKitPluginsUtils.removeCollapsedMark)(value, change, type);
            change.focus();
            change.addMark(newMark);
          } else {
            (0, _slateKitPluginsUtils.removeExpandedMark)(document, selection, change, type);
            change.addMarkAtRange(selection, newMark);
          }
        }
      } else if ((0, _tinycolor2.default)(color).toName() !== defaultColor) {
        var mark = new _slate.Mark({
          type: type,
          data: _slate.Data.create((0, _defineProperty3.default)({}, data, color))
        });
        if (selection.isCollapsed) {
          change.addMark(mark);
        } else {
          (0, _slateKitPluginsUtils.removeExpandedMark)(document, selection, change, type);
          change.addMarkAtRange(selection, mark);
        }
      }
      change.focus();
      return change;
    }
  };
}