"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

exports.default = createPlugin;

var _options = require("./options");

var _options2 = _interopRequireDefault(_options);

var _changes = require("./changes");

var _changes2 = _interopRequireDefault(_changes);

var _renderMark = require("./renderMark");

var _renderMark2 = _interopRequireDefault(_renderMark);

var _utils = require("./utils");

var _utils2 = _interopRequireDefault(_utils);

var _schemas = require("./schemas");

var _schemas2 = _interopRequireDefault(_schemas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPlugin(pluginOptions) {
  var options = _options2.default.create(pluginOptions);
  var changes = (0, _changes2.default)(options);
  var renderMark = (0, _renderMark2.default)(options);
  var schemas = (0, _schemas2.default)(options);
  var utils = (0, _utils2.default)(options);
  return (0, _extends3.default)({ options: options, changes: changes, utils: utils, renderMark: renderMark }, schemas);
}