"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _immutable = require("immutable");

var _isPlainObject = require("is-plain-object");

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOptions = {
  type: undefined,
  styles: undefined,
  data: undefined,
  defaultColor: undefined,
  alpha: 1
};

var Options = function (_Record) {
  (0, _inherits3.default)(Options, _Record);

  function Options() {
    (0, _classCallCheck3.default)(this, Options);
    return (0, _possibleConstructorReturn3.default)(this, (Options.__proto__ || (0, _getPrototypeOf2.default)(Options)).apply(this, arguments));
  }

  (0, _createClass3.default)(Options, [{
    key: "toJS",


    /**
     * Alias `toJS`.
     */

    value: function toJS(options) {
      return this.toJSON(options);
    }
  }], [{
    key: "create",
    value: function create() {
      var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (Options.isOptions(attrs)) return attrs;
      if ((0, _isPlainObject2.default)(attrs)) return Options.fromJSON(attrs);

      throw new Error("`Options.create` only accepts objects, strings or options");
    }
  }, {
    key: "fromJSON",
    value: function fromJSON(object) {
      if (Options.isOptions(object)) return object;

      var type = object.type,
          data = object.data,
          styles = object.styles,
          defaultColor = object.defaultColor,
          _object$alpha = object.alpha,
          alpha = _object$alpha === undefined ? 1 : _object$alpha;

      if (!type || !data || !styles || !defaultColor || !Array.isArray(styles)) {
        throw new Error("Highlight text require type, data and style option");
      }

      if (alpha < 0 || alpha > 1) {
        throw new Error("Alpha value can only go from 0 to 1");
      }

      return new Options({
        type: type,
        data: data,
        styles: styles,
        alpha: alpha,
        defaultColor: defaultColor
      });
    }
  }, {
    key: "isOptions",
    value: function isOptions(any) {
      return !!(any instanceof _immutable.Record && ["type", "data", "styles", "defaultColor"].every(function (key) {
        return any.has(key);
      }));
    }
  }]);
  return Options;
}((0, _immutable.Record)(defaultOptions, "highlight text option"));

exports.default = Options;