"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

exports.default = createRenderMark;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

require("slate");

var _tinycolor = require("tinycolor2");

var _tinycolor2 = _interopRequireDefault(_tinycolor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultStyle = {
  textDecoration: "inherit",
  textDecorationColor: "inherit"
};
function createRenderMark(opt) {
  var type = opt.type,
      dataField = opt.data,
      styleFields = opt.styles,
      alpha = opt.alpha;

  return function (props) {
    if (props.mark.type === type) {
      var _children = props.children,
          _attributes = props.attributes,
          data = props.mark.data;

      var _ref = _attributes || {},
          style = _ref.style;

      var color = (0, _tinycolor2.default)(data.get(dataField));
      style = (0, _extends4.default)({}, defaultStyle, style, {
        textDecoration: "inherit",
        decorationStyle: "initial"
      }, styleFields.reduce(function (acc, styleField) {
        return (0, _extends4.default)({}, acc, (0, _defineProperty3.default)({}, styleField, color.setAlpha(alpha).toRgbString()));
      }, {}));
      return _react2.default.createElement(
        "span",
        (0, _extends4.default)({}, _attributes, { style: style }),
        _children
      );
    }
    return undefined;
  };
}