"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _set = require("babel-runtime/core-js/set");

var _set2 = _interopRequireDefault(_set);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = createUtils;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createUtils(opts) {
  var defaultColor = opts.defaultColor,
      data = opts.data,
      type = opts.type;

  return {
    currentColor: function currentColor(value) {
      if (value.activeMarks) {
        var activeColorMarks = value.activeMarks.filter(function (mark) {
          return mark.type === type;
        }).map(function (mark) {
          return mark.data.get(data);
        });
        var uniqueColorMarks = [].concat((0, _toConsumableArray3.default)(new _set2.default(activeColorMarks)));
        if (uniqueColorMarks.length !== 0) {
          return uniqueColorMarks[0];
        }
      }
      return defaultColor;
    }
  };
}